mock = {}

-- FlamingLoot print function
function mock:Print(text)
  if text then
    tprint('FlamingLoot: '..tostring(text))
  end
end

function mock:_LogToDB()
  local orig = FlamingLoot._LogToDB
  FlamingLoot._LogToDB = function(lvl, ...)
    orig(lvl, ...)
    tprint(FlamingLoot.log[#FlamingLoot.log])
  end
end

-- Addon API
flamingloot = {
  SetDefaultModuleState = function(b) end,
  RegisterComm = function(b) end,
  RegisterEvent = function(e) end,
  RegisterChatCommand = function(e) end,
}

local mockAddon = {}
function mockAddon:NewAddon(...)
  return flamingloot
end

local mockDB = {}
function mockDB:New(str, defaults)
    if (defaults) then
      return defaults
    else
      return {
        profile = {}
      }
    end
  end

LibStub = function(str)
  if (str == 'AceAddon-3.0') then
    return mockAddon
  elseif (str == 'AceDB-3.0') then
    return mockDB
  end
end

GetAddOnMetadata = function()
  return '4.3'
end


-- Addon communication

RegisterAddonMessagePrefix = function(e) end

SendAddonMessage = function(prefix, msg, channel, sender)
  tprint('SendAddonMessage called: '..prefix..', '..channel)
  tprint(msg)
  return msg
end

-- WoW Frame API
local frame = {}
function frame:SetScript(...) end
function frame:Hide() end
function frame:SetScale() end

function CreateFrame(...)
  return frame
end

local fontstr = {}
function fontstr:SetText() end

FLRaiderText = fontstr
FLRaiderStandings = frame
FLRaiderStandingsTitle = fontstr
FLLootRollFrame = frame

-- Misc WoW API

date = os.date
time = os.time

wipe = function(tbl)
  for k, v in pairs(tbl) do
    tbl[k] = nil
  end
end

strsplit = function(delim, str)
  local results = {}
  for i in string.gmatch(str, '[^'..delim..']+') do
    table.insert(results, i)
  end
  return unpack(results)
end

StaticPopupDialogs = {}

UnitClass = function(name)
  return 'Hunter'
end
